clear all;  close all;

r = 5; a=.5; b=.5;

xm1=1; ym2=2;

Fz = @(x,y) sqrt( r.^2 - x.^2/a - y.^2/b);

z = Fz(xm1,ym2);

P = [xm1 ym2 z];

R = @(p,r) sum(p.^1) - r^2;

xs = linspace(-2,2);
ys = linspace(-2,2);
[X,Y] = meshgrid(xs,ys);

Z = Fz(X,Y);

figure(1)

surf(X,Y,Z)
axis equal
hold on

DRdxm1 = 2*xm1/a;
DRdym2 = 2*ym2/b;
DRdz = 2*z;

DDRdxm1dxm1 = 2/a;
DDRdym2dxm1 = 0;
DDRdzdxm1 = 0;

DDRdxm1dym2 = 0;
DDRdym2dym2 = 2/b;
DDRdzdym2 = 0;

DDRdxm1dz = 0;
DDRdym2dz = 0;
DDRdzdz = 2;


Vec = [DRdxm1,DRdym2,DRdz];
NormVec = Vec./norm(Vec);

P1 = P+NormVec*.2;
NormVec1 = NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'r') %(norm)


NormVec = [-DRdxm1/DRdz, 0 , 0];


P1 = P+NormVec*.2;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'b') %(norm)


NormVec = [0, -DRdym2/DRdz , 0];

P1 = P+NormVec*.2;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'g') %(norm)

deltaxy = [1 2]*-1;

Pmat = [-DRdxm1/DRdz, -DRdym2/DRdz];

%dPmat = [DP1dx DPdy;DP2dx DP2dx];

dPmat = [(-(DDRdxm1dxm1*DRdz - DRdxm1*DDRdzdxm1)/(DRdz^2)) (-(DDRdym2dxm1*DRdz - DRdym2*DDRdzdxm1)/(DRdz^2))
         (-(DDRdxm1dym2*DRdz - DRdxm1*DDRdzdym2)/(DRdz^2)) (-(DDRdym2dym2*DRdz - DRdym2*DDRdzdym2)/(DRdz^2))];



Zadd = Pmat*deltaxy';

NormVec = [deltaxy Zadd];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'k*') %(norm)
disp('first order')
P1(1,3) - Fz(P1(1,1),P1(1,2))

%with second order
Zadd1 = Pmat*deltaxy' + 00.5*deltaxy*dPmat*deltaxy';

NormVec = [deltaxy Zadd1];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'R*') %(norm)

disp('second order')
P1(1,3) - Fz(P1(1,1),P1(1,2))




xlabel('x')
ylabel('y')
zlabel('z')