clear all;  close all;

r =20; a=.2; b=.4;

xm1=.5; ym2=1;

Fz = @(x,y) ( r.^2 - x.^2./a - y.^2./b).^0.5;

delts = [linspace(0.001,0.099, 99) linspace(.1,1,50)]'*1;
deltaxy = -delts*[1 1];

R = @(x,y,z) (x.^2./a.^2 + y.^2./b.^2 + z.^2)./r.^2 - 1;

z = Fz(xm1,ym2)+0;

P = [xm1 ym2 z];

R = @(p,r) sum(p.^1) - r^2;

xs = linspace(-2,2);
ys = linspace(-2,2);
[X,Y] = meshgrid(xs,ys);

Z = Fz(X,Y);

figure(1)
axis equal
surf(X,Y,Z)

hold on

DRdxm1 = 2*xm1/a;
DRdym2 = 2*ym2/b;
DRdz = 2*z;

DDRdxm1dxm1 = 2/a;
DDRdym2dxm1 = 0;
DDRdzdxm1 = 0;

DDRdxm1dym2 = 0;
DDRdym2dym2 = 2/b;
DDRdzdym2 = 0;

DDRdxm1dz = 0;
DDRdym2dz = 0;
DDRdzdz = 2;


Vec = [DRdxm1,DRdym2,DRdz];
NormVec = Vec./norm(Vec);

P1 = P+NormVec*.2;
NormVec1 = NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'r') %(norm)


NormVec = [-DRdxm1/DRdz, 0 , 0];


P1 = P+NormVec*.2;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'b*') %(norm)


NormVec = [0, -DRdym2/DRdz , 0];

P1 = P+NormVec*.2;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'g.') %(norm)





disp('first order Ellimination Approx')
Pmat = [-DRdxm1/DRdz, -DRdym2/DRdz];

%dPmat = [DP1dx DPdy;DP2dx DP2dx];

dPmat = [(-(DDRdxm1dxm1*DRdz - DRdxm1*DDRdzdxm1)/(DRdz^2))  (-(DDRdym2dxm1*DRdz - DRdym2*DDRdzdxm1)/(DRdz^2))
         (-(DDRdxm1dym2*DRdz - DRdxm1*DDRdzdym2)/(DRdz^2))  (-(DDRdym2dym2*DRdz - DRdym2*DDRdzdym2)/(DRdz^2))];

Pmat
dPmat


for i = 1:size(deltaxy,1)
    Zadd(i,1) = Pmat*deltaxy(i,:)';
end
NormVec = [deltaxy Zadd];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'k.') %(norm)

err1_vec_first(:,1) = P1(:,3) - Fz(P1(:,1),P1(:,2));

%with second order

for i = 1:size(deltaxy,1)
    Zadd1(i,1) = Pmat*deltaxy(i,:)' + 0.5*deltaxy(i,:)*dPmat*deltaxy(i,:)';
end
NormVec = [deltaxy Zadd1];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'r*') %(norm)

disp('second order')
err1_vec_second(:,1) = P1(:,3) - Fz(P1(:,1),P1(:,2));

xlabel('x')
ylabel('y')
zlabel('z')

Pmat
dPmat


disp('first order Ellimination Approx2')
Pmat = [-DRdxm1/DRdz, -DRdym2/DRdz];

%dPmat = [DP1dx DPdy;DP2dx DP2dx];
dzdx1 = -DRdxm1/DRdz;
dzdx2 = -DRdym2/DRdz;

DDRdzdxm1S = DDRdzdz*dzdx1+DDRdzdxm1;
DDRdzdym2S = DDRdzdz*dzdx2+DDRdzdym2;

DDRdxm1dxm1S = DDRdzdxm1*dzdx1 + DDRdxm1dxm1;
DDRdxm1dym2S = DDRdzdxm1*dzdx2 + DDRdxm1dym2;

DDRdym2dxm1S = DDRdzdym2*dzdx1 + DDRdym2dxm1;
DDRdym2dym2S = DDRdzdym2*dzdx2 + DDRdym2dym2;



dPmat = [(-(DDRdxm1dxm1S*DRdz - DRdxm1*DDRdzdxm1S)/(DRdz^2))  (-(DDRdym2dxm1S*DRdz - DRdym2*DDRdzdxm1S)/(DRdz^2))
         (-(DDRdxm1dym2S*DRdz - DRdxm1*DDRdzdym2S)/(DRdz^2))  (-(DDRdym2dym2S*DRdz - DRdym2*DDRdzdym2S)/(DRdz^2))];

Pmat
dPmat


for i = 1:size(deltaxy,1)
    Zadd(i,1) = Pmat*deltaxy(i,:)';
end
NormVec = [deltaxy Zadd];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'k.') %(norm)

err1_vec_first(:,1) = P1(:,3) - Fz(P1(:,1),P1(:,2));

%with second order

for i = 1:size(deltaxy,1)
    Zadd1(i,1) = Pmat*deltaxy(i,:)' + 0.5*deltaxy(i,:)*dPmat*deltaxy(i,:)';
end
NormVec = [deltaxy Zadd1];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'r*') %(norm)

disp('second order')
err1_vec_second(:,1) = P1(:,3) - Fz(P1(:,1),P1(:,2));

xlabel('x')
ylabel('y')
zlabel('z')

Pmat
dPmat


disp('first order Ellimination Method')
x = xm1;
y = ym2;

dZdx =-x./(a*(r.^2 - x.^2/a - y.^2./b).^(1/2));
dZdy =-y./(b.*(r.^2 - x.^2/a - y.^2./b).^(1/2));

ddZdxdx =- 1./(a.*(r.^2 - x^2./a - y^2./b).^(1./2)) - x.^2./(a.^2.*(r.^2 - x.^2./a - y.^2./b).^(3./2));
ddZdxdy =-(x.*y)./(a.*b.*(r.^2 - x.^2./a - y.^2./b).^(3./2));
ddZdydx =-(x.*y)./(a.*b.*(r.^2 - x.^2./a - y.^2./b).^(3./2));
ddZdydy =- 1./(b.*(r.^2 - x.^2./a - y^2./b).^(1./2)) - y.^2./(b.^2*(r.^2 - x^2./a - y^2./b).^(3./2));

Pmat1 = [dZdx,dZdy]; %Fz = @(x,y) sqrt( r.^2 - x.^2/a - y.^2/b);

% dPmat = [DP1dx DPdy;DP2dx DP2dx];

dPmat1 = [ddZdxdx ddZdxdy
         ddZdydx ddZdydy];

Pmat1
dPmat1

for i = 1:size(deltaxy,1)
    Zadd(i,1) = Pmat1*deltaxy(i,:)';
end
NormVec = [deltaxy Zadd];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'k^') %(norm)


err2_vec_first(:,1) = P1(:,3) - Fz(P1(:,1),P1(:,2));

% with second order

for i = 1:size(deltaxy,1)
    Zadd1(i,1) = Pmat1*deltaxy(i,:)' + 0.5*deltaxy(i,:)*dPmat1*deltaxy(i,:)';
end
NormVec = [deltaxy Zadd1];

P1 = P+NormVec;

Line = [P;P1];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'r^') %(norm)

disp('second order')
err2_vec_second(:,1) = P1(:,3) - Fz(P1(:,1),P1(:,2));

xlabel('x')
ylabel('y')
zlabel('z')

disp('first order Ellimination Method 2')
x = xm1;
y = ym2;
dZdx =-x./(a.*z);
dZdy =-y./(b.*z);
ddZdxdx =- 1./(a.*z) - x.^2./(a.^2.*z.^3);
ddZdxdy =-(x.*y)./(a.*b.*z.^3);
ddZdydx =-(x.*y)./(a.*b.*z.^3);
ddZdydy =- 1./(b.*z) - y.^2./(b.^2.*z.^3);
dZdx2 = -2/a^2;

Pmat1 = [dZdx,dZdy]; %Fz = @(x,y) sqrt( r.^2 - x.^2/a - y.^2/b);

%dPmat = [DP1dx DPdy;DP2dx DP2dx];

dPmat1 = [ddZdxdx ddZdxdy
         ddZdydx ddZdydy];

Pmat1
dPmat1

for i = 1:size(deltaxy,1)
    Zadd(i,1) = Pmat1*deltaxy(i,:)';
end
NormVec = [deltaxy Zadd];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'k^') %(norm)


err2_vec_first(:,1) = P1(:,3) - Fz(P1(:,1),P1(:,2));

%with second order

for i = 1:size(deltaxy,1)
    Zadd1(i,1) = Pmat1*deltaxy(i,:)' + 0.5*deltaxy(i,:)*dPmat1*deltaxy(i,:)';
end
NormVec = [deltaxy Zadd1];

P1 = P+NormVec;

Line = [P;P1];

P1 = P+NormVec;

Line = [P;P1];

plot3(Line(:,1),Line(:,2),Line(:,3),'r^') %(norm)

disp('second order')
err2_vec_second(:,1) = P1(:,3) - Fz(P1(:,1),P1(:,2));

xlabel('x')
ylabel('y')
zlabel('z')



figure(2)
plot(delts,log(([err1_vec_first err1_vec_second err2_vec_first err2_vec_second].^2).^0.5))
legend('err1 vec first','err1 vec second','err2 vec first','err2 vec second')

figure(3)
plot(delts,log(([err1_vec_second  - err2_vec_second].^2).^0.5))
legend('Difference in second order')


figure(4)
plot(delts,(([err1_vec_first err1_vec_second err2_vec_first err2_vec_second]).^2).^0.5)
legend('err1 vec first','err1 vec second','err2 vec first','err2 vec second')


R = @(x,y,z) (x.^2./a.^2 + y.^2./b.^2 + z.^2)./r.^2 - 1;


dR = [2.*xm1./a.^2, 2.*ym1./b.^2, z]./r.^2;
ddR = [2./a.^2, 0, 0;
       0, 2./b.^2, 0;
       0, 0, 2]./r.^2;

for i = 1:size(deltaxy,1)
    
    Zadd1(i,1) = Pmat1*deltaxy(i,:)' + 0.5*deltaxy(i,:)*dPmat1*deltaxy(i,:)';
end

