clear all; close all, figure(10)
%note (1)lagrangian (2)Full deriv (3) partial cb2 version

resultfiles = {'Result_1to1_Width_1_Height_1_hmax_0.08'
    'Result_1to2_Width_1.41_Height_0.71_hmax_0.08'
    'Result_1to5_Width_2.24_Height_0.45_hmax_0.08'
    'Result_1to10_Width_3.16_Height_0.32_hmax_0.08'
    'Result_1to20_Width_4.47_Height_0.22_hmax_0.08'
    'Result_1to40_Width_6.32_Height_0.16_hmax_0.08'
    'Result_1to60_Width_7.75_Height_0.13_hmax_0.08'
    'Result_1to80_Width_8.94_Height_0.11_hmax_0.08'};

% load([resultfiles{1} '.mat'])

%% Iteration counter
clear resultfiles
resultfiles = {'Result_1to1_Width_1_Height_1_hmax_0.2'};
load([resultfiles{1} '.mat'])
remeshPoints = zeros(0,2);
ErrorSet = zeros(20,2);
for i = 1:2
%     detailinf{1}.NormUpdates, detailinf{2}.NormUpdates, detailinf{3}.NormUpdates
    figure(10)
    hold on
    Iters = size(detailinf{i}.NormUpdates,1);
    UpdateNos = find(detailinf{i}.NormUpdates > 0);
    NoOfUpdates = size(UpdateNos,1);
    Errors = log10(detailinf{i}.NormUpdates(UpdateNos));
    plot(1:NoOfUpdates,Errors);
    remeshPoints = [remeshPoints; 1,  Errors(1)];
    
%     for j = 1:size(UpdateNos,1)-1
%         if UpdateNos(j) ~= UpdateNos(j+1)-1
%             remeshPoints = [remeshPoints; j+1,  Errors(j+1)];
%         else
%             if detailinf{i}.RemeshedAtIter(UpdateNos(j+1)) > 0
%                 remeshPoints = [remeshPoints; j+1,  Errors(j+1)];
%             end              
%         end
%     end
    tempremeshnos = find(detailinf{i}.RemeshedAtIter(UpdateNos)>0);
    remeshPoints = [remeshPoints;tempremeshnos ,  Errors(tempremeshnos)];
    temp = [Errors;zeros(20,1)];
    ErrorSet(:,i) = temp(1:20,1);
    temp = [detailinf{i}.NormUpdates(UpdateNos);zeros(20,1)];
    NormSet(:,i) = temp(1:20,1);
end

plot(remeshPoints(:,1),remeshPoints(:,2),'k.')
legend({'Lagrangian','Master-Slave Elimination','Remesh points'})
title({'Convergence of 2D mesher : With MPC implementaions'})
xlabel('Newton Iteration')
ylabel('Log(Norm(err))')

%% Write histogram comparrison

% Ratios = '';
% Lagrangian = 'Lagrangian';
% MasterSlave = 'Master-Slave (full deriv)';
% MasterSlave2 = 'Master-Slave (partial derivs)';
% for i = 1:size(resultfiles)
%    load([resultfiles{i} '.mat'])
%
%
%    Ratios = [Ratios ', ' num2str(HW(Aspects,1)) ':' num2str(HW(Aspects,2))];
%    Lagrangian = [Lagrangian ',' num2str(size(find(detailinf{1}.NormUpdates > 0),1)) ];
%    MasterSlave = [MasterSlave ',' num2str(size(find(detailinf{2}.NormUpdates > 0),1))];
%    MasterSlave2 = [MasterSlave2 ',' num2str(size(find(detailinf{3}.NormUpdates > 0),1))];
% end
%
% fid = fopen( 'Lag_vs_MS_IterationComparrison.csv', 'w' );%Bar chart ready info for lagrangian vs Master slave
%
% fprintf( fid, '%s\r\n', Ratios );
% fprintf( fid, '%s\r\n', Lagrangian);
% fprintf( fid, '%s\r\n', MasterSlave);
% fprintf( fid, '%s\r\n', MasterSlave2);
% fclose(fid);fclose('all');
%


%% Write Stacked histogram comparrison Times

% Ratios = ',,';
% Lagrangian = ',Lagrangian';
% MasterSlave = ',Master-Slave (full deriv)';
% MasterSlave2 = ',Master-Slave (partial derivs)';
% 
% fid = fopen( 'Lag_vs_MS_TimeComparrisonHmax_0.02.csv', 'w' );%Bar chart ready info for lagrangian vs Master slave
% fprintf( fid, '%s\r\n', ',,Remeshing,Truss Contribution,MPC Contribution,Solve Contribution,Total Time' );
% fprintf( fid, '%s\r\n', '' );
% fprintf( fid, '%s\r\n', ',,Remeshing,Truss Contribution,MPC Contribution,Solve Contribution,Total Time' );
% 
% for i = 1:size(resultfiles)
%     load([resultfiles{i} '.mat'])
%     Ratio = ['H:W =' num2str(HW(Aspects,1)) ':' num2str(HW(Aspects,2))];
%     Lagrangian = ',Lagrangian';
%     MasterSlave = ',Master-Slave (full deriv)';
%     MasterSlave2 = ',Master-Slave (partial derivs)';
%     
%     j = 1;
%     total = sum(detailinf{j}.RemeshedTimes) + sum(detailinf{j}.TrussContributionTimer) + (sum(detailinf{j}.MPCTimes)) + (sum(detailinf{j}.SystemSolveTimes));
%     Lagrangian = [Lagrangian ',' num2str(sum(detailinf{j}.RemeshedTimes)) ',' num2str(sum(detailinf{j}.TrussContributionTimer)) ',' num2str(sum(detailinf{j}.MPCTimes)) ',' num2str(sum(detailinf{j}.SystemSolveTimes)) ',' num2str(total)];
%     
%     j = 2;
%      total = sum(detailinf{j}.RemeshedTimes) + sum(detailinf{j}.TrussContributionTimer) + (sum(detailinf{j}.MPCTimes)) + (sum(detailinf{j}.SystemSolveTimes));
%   MasterSlave = [MasterSlave ',' num2str(sum(detailinf{j}.RemeshedTimes)) ',' num2str(sum(detailinf{j}.TrussContributionTimer)) ',' num2str(sum(detailinf{j}.MPCTimes)) ',' num2str(sum(detailinf{j}.SystemSolveTimes)) ',' num2str(total)];
%     
%     j = 3;
%    total = sum(detailinf{j}.RemeshedTimes) + sum(detailinf{j}.TrussContributionTimer) + (sum(detailinf{j}.MPCTimes)) + (sum(detailinf{j}.SystemSolveTimes));
%   MasterSlave2 = [MasterSlave2 ',' num2str(sum(detailinf{j}.RemeshedTimes)) ',' num2str(sum(detailinf{j}.TrussContributionTimer)) ',' num2str(sum(detailinf{j}.MPCTimes)) ',' num2str(sum(detailinf{j}.SystemSolveTimes)) ',' num2str(total)];
%       
%     fprintf( fid, '%s\r\n', Ratio );
%     fprintf( fid, '%s\r\n', Lagrangian);
%     fprintf( fid, '%s\r\n', MasterSlave);
%     fprintf( fid, '%s\r\n', MasterSlave2);
%     fprintf( fid, '%s\r\n', '');
% end

% fclose(fid);fclose('all');

%% Write Stacked histogram comparrison Times and iters
% Ratios = ',,';
% Lagrangian = ',Lagrangian';
% MasterSlave = ',Master-Slave (full deriv)';
% MasterSlave2 = ',Master-Slave (partial derivs)';
% 
% fid = fopen( 'Lag_vs_MS_TimeComparrisonHmax_0.023.csv', 'w' );%Bar chart ready info for lagrangian vs Master slave
% fprintf( fid, '%s\r\n', ',,Iterations,Remeshing,Truss Contribution,MPC Contribution,Solve Contribution,Total Time' );
% 
% 
% for i = 1:size(resultfiles)
%     load([resultfiles{i} '.mat'])
%     Ratio = ['H:W =' num2str(HW(Aspects,1)) ':' num2str(HW(Aspects,2))];
%     Lagrangian = ',Lagrangian';
%     MasterSlave = ',Master-Slave (full deriv)';
%     MasterSlave2 = ',Master-Slave (partial derivs)';
%     
%     % iterations
%     j = 1;
%     Lagrangian = [Lagrangian ',' num2str(size(find(detailinf{i}.NormUpdates>0),1))];
%     
%     j = 2;
%     MasterSlave = [MasterSlave ','  num2str(size(find(detailinf{i}.NormUpdates>0),1))];
%     
%     j = 3;
%     MasterSlave2 = [MasterSlave2 ',' num2str(size(find(detailinf{i}.NormUpdates>0),1))];
%     
%     j = 1;
%     total = sum(detailinf{j}.RemeshedTimes) + sum(detailinf{j}.TrussContributionTimer) + (sum(detailinf{j}.MPCTimes)) + (sum(detailinf{j}.SystemSolveTimes));
%     Lagrangian = [Lagrangian ',' num2str(sum(detailinf{j}.RemeshedTimes)) ',' num2str(sum(detailinf{j}.TrussContributionTimer)) ',' num2str(sum(detailinf{j}.MPCTimes)) ',' num2str(sum(detailinf{j}.SystemSolveTimes)) ',' num2str(total)];
%     
%     j = 2;
%     total = sum(detailinf{j}.RemeshedTimes) + sum(detailinf{j}.TrussContributionTimer) + (sum(detailinf{j}.MPCTimes)) + (sum(detailinf{j}.SystemSolveTimes));
%     MasterSlave = [MasterSlave ',' num2str(sum(detailinf{j}.RemeshedTimes)) ',' num2str(sum(detailinf{j}.TrussContributionTimer)) ',' num2str(sum(detailinf{j}.MPCTimes)) ',' num2str(sum(detailinf{j}.SystemSolveTimes)) ',' num2str(total)];
%     
%     j = 3;
%     total = sum(detailinf{j}.RemeshedTimes) + sum(detailinf{j}.TrussContributionTimer) + (sum(detailinf{j}.MPCTimes)) + (sum(detailinf{j}.SystemSolveTimes));
%     MasterSlave2 = [MasterSlave2 ',' num2str(sum(detailinf{j}.RemeshedTimes)) ',' num2str(sum(detailinf{j}.TrussContributionTimer)) ',' num2str(sum(detailinf{j}.MPCTimes)) ',' num2str(sum(detailinf{j}.SystemSolveTimes)) ',' num2str(total)];
% 
%     fprintf( fid, '%s\r\n', Ratio );
%     fprintf( fid, '%s\r\n', Lagrangian);
%     fprintf( fid, '%s\r\n', MasterSlave);
%     fprintf( fid, '%s\r\n', MasterSlave2);
%     fprintf( fid, '%s\r\n', '');
%     
% end
% 
% fclose(fid);fclose('all');