clc; clear all; close all;

filenames = {'P_000980_Bars_6533_PerMPC_000_Hmax_0.2.mat'
    'P_000980_Bars_6533_PerMPC_020_Hmax_0.2.mat'
    'P_000980_Bars_6533_PerMPC_040_Hmax_0.2.mat'
    'P_000980_Bars_6533_PerMPC_060_Hmax_0.2.mat'
    'P_000980_Bars_6533_PerMPC_080_Hmax_0.2.mat'
    'P_000980_Bars_6533_PerMPC_100_Hmax_0.2.mat'
    'P_002363_Bars_15985_PerMPC_000_Hmax_0.15.mat'
    'P_002363_Bars_15985_PerMPC_020_Hmax_0.15.mat'
    'P_002363_Bars_15985_PerMPC_040_Hmax_0.15.mat'
    'P_002363_Bars_15985_PerMPC_060_Hmax_0.15.mat'
    'P_002363_Bars_15985_PerMPC_080_Hmax_0.15.mat'
    'P_002363_Bars_15985_PerMPC_100_Hmax_0.15.mat'
    'P_004110_Bars_28148_PerMPC_000_Hmax_0.125.mat'
    'P_004110_Bars_28148_PerMPC_020_Hmax_0.125.mat'
    'P_004110_Bars_28148_PerMPC_040_Hmax_0.125.mat'
    'P_004110_Bars_28148_PerMPC_060_Hmax_0.125.mat'
    'P_004110_Bars_28148_PerMPC_080_Hmax_0.125.mat'
    'P_004110_Bars_28148_PerMPC_100_Hmax_0.125.mat'
    'P_008054_Bars_55540_PerMPC_000_Hmax_0.1.mat'
    'P_008054_Bars_55540_PerMPC_020_Hmax_0.1.mat'
    'P_008054_Bars_55540_PerMPC_040_Hmax_0.1.mat'
    'P_008054_Bars_55540_PerMPC_060_Hmax_0.1.mat'
    'P_008054_Bars_55540_PerMPC_080_Hmax_0.1.mat'
    'P_008054_Bars_55540_PerMPC_100_Hmax_0.1.mat'
    'P_015835_Bars_109691_PerMPC_000_Hmax_0.08.mat'
    'P_015835_Bars_109691_PerMPC_020_Hmax_0.08.mat'
    'P_015835_Bars_109691_PerMPC_040_Hmax_0.08.mat'
    'P_015835_Bars_109691_PerMPC_060_Hmax_0.08.mat'
    'P_015835_Bars_109691_PerMPC_080_Hmax_0.08.mat'
    'P_015835_Bars_109691_PerMPC_100_Hmax_0.08.mat'
    'P_019172_Bars_132907_PerMPC_000_Hmax_0.075.mat'
    'P_019172_Bars_132907_PerMPC_020_Hmax_0.075.mat'
    'P_019172_Bars_132907_PerMPC_040_Hmax_0.075.mat'
    'P_019172_Bars_132907_PerMPC_060_Hmax_0.075.mat'
    'P_019172_Bars_132907_PerMPC_080_Hmax_0.075.mat'
    'P_019172_Bars_132907_PerMPC_100_Hmax_0.075.mat'
    'P_023616_Bars_163876_PerMPC_000_Hmax_0.07.mat'
    'P_023616_Bars_163876_PerMPC_020_Hmax_0.07.mat'
    'P_023616_Bars_163876_PerMPC_040_Hmax_0.07.mat'
    'P_023616_Bars_163876_PerMPC_060_Hmax_0.07.mat'
    'P_023616_Bars_163876_PerMPC_080_Hmax_0.07.mat'
    'P_023616_Bars_163876_PerMPC_100_Hmax_0.07.mat'
    'P_037538_Bars_260825_PerMPC_000_Hmax_0.06.mat'};
         
         
Ratios = ',,';
fid = fopen( 'Lag_vs_MS_TimeComparrison.csv', 'w' );

fprintf( fid, '%s\r\n', ['Np, % MPC, Nmpc, NDof, NoBars, TrussAsmTime(s), Hmax,' ...
    'Lag SolveDOF Count, MSE SolveDOF Count,'...
    'Lag NNZ, MSE NNZ,'...
    'Lag MPC Times, MSE MPC Times,'...
    'Lag Solve Times, MSE Solve Times,'...
    'Lag MPC Resolve Times, MSE MPC Resolve Times']);

for filenum = 1:size(filenames,1)
    file = filenames{filenum};
    load(file);
    Lag = detailinf{1};
    MSE = detailinf{2};
    data(filenum,:) = [Lag.PCounter Percentage Lag.MpcCounter Lag.NDof Lag.NoBars Lag.TrussContributionTimer h_max ...
        Lag.SolveDofCounter MSE.SolveDofCounter...
        Lag.NonZeros MSE.NonZeros...
        Lag.MPCTimes MSE.MPCTimes...
        Lag.SystemSolveTimes MSE.SystemSolveTimes...
        Lag.MPCResolveCounter MSE.MPCResolveCounter];
end
strout = '';
for i = 1:size(data,2)
    strout = [strout '%12.8f, '];
end
strout = [strout '\r\n'];
fprintf( fid, strout, data' );

         fclose(fid); clear fid