%eradicate tet
function eradTet
clc; clear all
Ps =[0     0     0
    0     1     0
    1     0     0
    1     1     0
    0     0     1
    0     1     1
    1     0     1
    1     1     1];

Tets = delaunay(Ps)
MESHplotter3D(Ps,Tets,1)

Ps2 = [Ps; 0.5 0.5 0.5];
Tets = delaunay(Ps2)
MESHplotter3D(Ps2,Tets,2)
Ps3 = [Ps2; 0.5 0.55 0.5];
Tets = delaunay(Ps3)
MESHplotter3D(Ps3,Tets,3)

miscps = [0.45 0.5 0.0
          0.45 0.5 1
          0.5  0.0 0.5
          0.5  1   0.5];
      
miscps = [miscps; miscps + .1*[ones(4,1) zeros(4,2)]];

Ps4 = [Ps;
    miscps];
Tets = delaunay(Ps4)
MESHplotter3D(Ps4,Tets,4)

qual = simpqual(Ps4,Tets);
tetcon = find(qual == min(qual));
Tets2 = sort(Tets,2);

Ps6 = [Ps4; (sum(Ps4(Tets2(tetcon,:),:),1)/4)];
Tets = delaunay(Ps6);
MESHplotter3D(Ps6,Tets,6)

end

function [a] = MESHplotter3D(p,tet,fignum)
figure(fignum); cla
% simpplot(p,t,'p(:,2)>0');
% title(['Retriangulation #'])
%         drawnow
t = unique(sort([tet(:,[1,2,3]);tet(:,[1,2,4]);tet(:,[1,3,4]);tet(:,[2,3,4]);],2),'rows');
cla;
s1 = patch('vertices',p,'faces',t,'edgecol','k','facecol',[.8,.9,1]);
s1.FaceAlpha = 0.01;
axis equal

% draw low quality elements
qual = simpqual(p,tet,1);
AD = find(qual<.4);

t = unique(sort([tet(AD,[1,2,3]);tet(AD,[1,2,4]);tet(AD,[1,3,4]);tet(AD,[2,3,4]);],2),'rows');

hold on

s2 = patch('vertices',p,'faces',t,'edgecol','k','facecol','r'); drawnow;
s2.FaceAlpha = 0.3;
hold off
end