function[dFdu,broken,Ft] = CB_3dtruss_CT(u,x,Ldes)

x1 = x(1) + u(1);
x2 = x(2) + u(2);
x3 = x(3) + u(3);
x4 = x(4) + u(4);
x5 = x(5) + u(5);
x6 = x(6) + u(6);

broken = false;

inLc = (x5-x2)^2+(x4-x1)^2+(x6-x3)^2;
Lc = (inLc)^0.5;

if round(Lc*10000) == 0
    broken = true;
end


    %div desired length
       
    Fbar = (Ldes-Lc)/Ldes;
    
    l = (x4-x1)/Lc;
    m = (x5-x2)/Lc;
    n = (x6-x3)/Lc;
    
    F1u1 = (Ldes-Lc)/(Ldes*Lc)-((2*x1-2*x4)*(x1-x4))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x1-2*x4)*(x1-x4))/(2*Ldes*inLc^(3/2));
    F1u2 = -((2*x2-2*x5)*(x1-x4))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x2-2*x5)*(x1-x4))/(2*Ldes*inLc^(3/2));
    F1u3 = -((2*x3-2*x6)*(x1-x4))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x3-2*x6)*(x1-x4))/(2*Ldes*inLc^(3/2));
    F1u4 = ((2*x1-2*x4)*(x1-x4))/(2*Ldes*inLc)-(Ldes-Lc)/(Ldes*Lc)+((Ldes-Lc)*(2*x1-2*x4)*(x1-x4))/(2*Ldes*inLc^(3/2));
    F1u5 = ((2*x2-2*x5)*(x1-x4))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x2-2*x5)*(x1-x4))/(2*Ldes*inLc^(3/2));
    F1u6 = ((2*x3-2*x6)*(x1-x4))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x3-2*x6)*(x1-x4))/(2*Ldes*inLc^(3/2));
%     F2u1 = -((2*x1-2*x4)*(x2-x5))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x1-2*x4)*(x2-x5))/(2*Ldes*inLc^(3/2));
    F2u2 = (Ldes-Lc)/(Ldes*Lc)-((2*x2-2*x5)*(x2-x5))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x2-2*x5)*(x2-x5))/(2*Ldes*inLc^(3/2));
    F2u3 = -((2*x3-2*x6)*(x2-x5))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x3-2*x6)*(x2-x5))/(2*Ldes*inLc^(3/2));
    F2u4 = ((2*x1-2*x4)*(x2-x5))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x1-2*x4)*(x2-x5))/(2*Ldes*inLc^(3/2));
    F2u5 = ((2*x2-2*x5)*(x2-x5))/(2*Ldes*inLc)-(Ldes-Lc)/(Ldes*Lc)+((Ldes-Lc)*(2*x2-2*x5)*(x2-x5))/(2*Ldes*inLc^(3/2));
    F2u6 = ((2*x3-2*x6)*(x2-x5))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x3-2*x6)*(x2-x5))/(2*Ldes*inLc^(3/2));
%     F3u1 = -((2*x1-2*x4)*(x3-x6))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x1-2*x4)*(x3-x6))/(2*Ldes*inLc^(3/2));
%     F3u2 = -((2*x2-2*x5)*(x3-x6))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x2-2*x5)*(x3-x6))/(2*Ldes*inLc^(3/2));
    F3u3 = (Ldes-Lc)/(Ldes*Lc)-((2*x3-2*x6)*(x3-x6))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x3-2*x6)*(x3-x6))/(2*Ldes*inLc^(3/2));
    F3u4 = ((2*x1-2*x4)*(x3-x6))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x1-2*x4)*(x3-x6))/(2*Ldes*inLc^(3/2));
    F3u5 = ((2*x2-2*x5)*(x3-x6))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x2-2*x5)*(x3-x6))/(2*Ldes*inLc^(3/2));
    F3u6 = ((2*x3-2*x6)*(x3-x6))/(2*Ldes*inLc)-(Ldes-Lc)/(Ldes*Lc)+((Ldes-Lc)*(2*x3-2*x6)*(x3-x6))/(2*Ldes*inLc^(3/2));
%     F4u1 = ((2*x1-2*x4)*(x1-x4))/(2*Ldes*inLc)-(Ldes-Lc)/(Ldes*Lc)+((Ldes-Lc)*(2*x1-2*x4)*(x1-x4))/(2*Ldes*inLc^(3/2));
%     F4u2 = ((2*x2-2*x5)*(x1-x4))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x2-2*x5)*(x1-x4))/(2*Ldes*inLc^(3/2));
%     F4u3 = ((2*x3-2*x6)*(x1-x4))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x3-2*x6)*(x1-x4))/(2*Ldes*inLc^(3/2));
    F4u4 = (Ldes-Lc)/(Ldes*Lc)-((2*x1-2*x4)*(x1-x4))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x1-2*x4)*(x1-x4))/(2*Ldes*inLc^(3/2));
    F4u5 = -((2*x2-2*x5)*(x1-x4))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x2-2*x5)*(x1-x4))/(2*Ldes*inLc^(3/2));
    F4u6 = -((2*x3-2*x6)*(x1-x4))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x3-2*x6)*(x1-x4))/(2*Ldes*inLc^(3/2));
%     F5u1 = ((2*x1-2*x4)*(x2-x5))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x1-2*x4)*(x2-x5))/(2*Ldes*inLc^(3/2));
%     F5u2 = ((2*x2-2*x5)*(x2-x5))/(2*Ldes*inLc)-(Ldes-Lc)/(Ldes*Lc)+((Ldes-Lc)*(2*x2-2*x5)*(x2-x5))/(2*Ldes*inLc^(3/2));
%     F5u3 = ((2*x3-2*x6)*(x2-x5))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x3-2*x6)*(x2-x5))/(2*Ldes*inLc^(3/2));
%     F5u4 = -((2*x1-2*x4)*(x2-x5))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x1-2*x4)*(x2-x5))/(2*Ldes*inLc^(3/2));
    F5u5 = (Ldes-Lc)/(Ldes*Lc)-((2*x2-2*x5)*(x2-x5))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x2-2*x5)*(x2-x5))/(2*Ldes*inLc^(3/2));
    F5u6 = -((2*x3-2*x6)*(x2-x5))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x3-2*x6)*(x2-x5))/(2*Ldes*inLc^(3/2));
%     F6u1 = ((2*x1-2*x4)*(x3-x6))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x1-2*x4)*(x3-x6))/(2*Ldes*inLc^(3/2));
%     F6u2 = ((2*x2-2*x5)*(x3-x6))/(2*Ldes*inLc)+((Ldes-Lc)*(2*x2-2*x5)*(x3-x6))/(2*Ldes*inLc^(3/2));
%     F6u3 = ((2*x3-2*x6)*(x3-x6))/(2*Ldes*inLc)-(Ldes-Lc)/(Ldes*Lc)+((Ldes-Lc)*(2*x3-2*x6)*(x3-x6))/(2*Ldes*inLc^(3/2));
%     F6u4 = -((2*x1-2*x4)*(x3-x6))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x1-2*x4)*(x3-x6))/(2*Ldes*inLc^(3/2));
%     F6u5 = -((2*x2-2*x5)*(x3-x6))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x2-2*x5)*(x3-x6))/(2*Ldes*inLc^(3/2));
    F6u6 = (Ldes-Lc)/(Ldes*Lc)-((2*x3-2*x6)*(x3-x6))/(2*Ldes*inLc)-((Ldes-Lc)*(2*x3-2*x6)*(x3-x6))/(2*Ldes*inLc^(3/2));



%Force vector constribution

Ft(1,1) = -Fbar*l;
Ft(2,1) = -Fbar*m;
Ft(3,1) = -Fbar*n;
Ft(4,1) =  Fbar*l;
Ft(5,1) =  Fbar*m;
Ft(6,1) =  Fbar*n;

dFdu = [F1u1 F1u2 F1u3 F1u4 F1u5 F1u6;
        F1u2 F2u2 F2u3 F2u4 F2u5 F2u6;
        F1u3 F2u3 F3u3 F3u4 F3u5 F3u6;
        F1u4 F2u4 F3u4 F4u4 F4u5 F4u6;
        F1u5 F2u5 F3u5 F4u5 F5u5 F5u6;
        F1u6 F2u6 F3u6 F4u6 F5u6 F6u6];
    
%
dFdu = -dFdu;
Ft = -Ft;
