%MESHDEMO2d Distmesh2d examples.

%   Copyright (C) 2004-2012 Per-Olof Persson. See COPYRIGHT.TXT for details.
clear all; clc; close all;
rand('state',1); % Always the same results
set(gcf,'renderer','opengl');

fstats=@(p,t) fprintf('%d nodes, %d elements, min quality %.2f\n', ...
                      size(p,1),size(t,1),min(simpqual(p,t)));

fprintf('Uniform Mesh on Unit Circle\n');
% echo on

% Cb2 FIXED Points on surface


%% Normal run
% Cb2 FIXED Points on surface
tol = 10^-8;
format short
format compact
r=1;
h0 = .05;
n = round(2*pi*r/(.95*h0));
 if mod(n,2) ==1 % this is to ensure that a odd number of pfix nodes exist. otherwise prgram fails
       n = n+2;
 end   
t = (0:1/(n*r):1)'+.01; %plot 40 points along boundary
pfix = [cos(2*pi()*t(1:end-1)) sin(2*pi()*t(1:end-1))]*r;

pfix = [pfix(:,2) pfix(:,1)];
fd=@(p) sqrt(sum(p.^2,2))-r;

legends = {};
cols = {};


% Alpha comparrison 0.77 0.78 0.79 0.8

   % TrussType,TrussS,Alpha,UseLenComp, Fscale
RunVariables = [2.0  0  20    0  1
                2.0  0  5     0  1
                2.0  0  1     0  1
                2.0  0  0.5   0  1
                2.0  0  0.1   0  1
                2.0  0  0.05  0  1
                2.0  0  0.01  0  1];

            %Length control comparrison
            
            %scale 0.1 10
               % TrussType,TrussS,Alpha,UseLenComp, Fscale
% RunVariables = [2.0  0  20  1  0.1
%                 2.0  0  20  1  0.8
%                 2.0  0  20  1  0.9
%                 2.0  0  20  1  1
%                 2.0  0  20  1  1.1
%                 2.0  0  20  1  1.2
%                 2.0  0  20  1  1.5 ];

scale = 0.5;
results = inf;
MeshedAtIter = 0;

% cols{size(cols,2)+1} = 'g'

remeshes = zeros(0,2);
for i = 1:size(RunVariables,1)
    [p,t, iters, updateNorms,AverageLcLdes,MeshedAtIter,AlphaUsed] = CB_distmesh2d(fd,@(p) huniformScale(p,h0,scale),h0,r.*[-1,-1;1,1],pfix,tol,RunVariables(i,1), RunVariables(i,2),RunVariables(i,3),RunVariables(i,4),RunVariables(i,5));
    minqual = min(simpqual(p,t))
    
    
    Lencontrol =['F_s_c_a_l_e = ' num2str(RunVariables(i,5))];
    
    
    tittext = {'Update Control Comparison','Truss Stiffness Formula : F_t_r_u_s_s = \DeltaL/L_d_e_s',['\alpha = ' num2str(RunVariables(i,3))]} % alpha update control
%     tittext = {'Length Normalisation Comparison','Truss Stiffness Formula : F_t_r_u_s_s = \DeltaL/L_d_e_s',[Lencontrol]} %Length control sim
    
    AllUpdates{i}=updateNorms;
    figure(i)
    cla,patch('vertices',p,'faces',t,'edgecol','k','facecol',[.8,.9,1]);
    drawnow
    axis square
    title(tittext)
    updateNorms2 = [updateNorms; 5*ones(100,1)];
    MeshedAtIter = [MeshedAtIter; zeros(100,1)];
    S1 = RunVariables(i,2)
    if results == inf
        results =      [i;RunVariables(i,3);RunVariables(i,4)*RunVariables(i,5);iters; AverageLcLdes; minqual; sum(MeshedAtIter);0;updateNorms2(1:50,1)];
    else
        results(:,i) = [i;RunVariables(i,3);RunVariables(i,4)*RunVariables(i,5);iters; AverageLcLdes; minqual; sum(MeshedAtIter);0;updateNorms2(1:50,1)];
    end
    
    figure(10)
    hold on
    plot(1:size(updateNorms,1),log10(updateNorms))
    drawnow
    
    remeshes = [remeshes; find(MeshedAtIter ==1) updateNorms2(find(MeshedAtIter ==1))];
    
    legends{size(legends,2)+1} = ['\alpha = ' num2str(RunVariables(i,3)) ] ; % Alpha control
%     legends{size(legends,2)+1} = [Lencontrol  ] ; % Length control
end
figure(10)
hold on
plot(remeshes(:,1),log10(remeshes(:,2)),'k.')
legend(legends)
legends{size(legends,2)+1} = 'Remeshes';

legends{size(legends,2)+1} ='Fbar = \DeltaL/L_d_e_s';
title({'Update Control Comparison','Truss Stiffness Formula : F_t_r_u_s_s = \DeltaL/L_d_e_s',['Scale = L_c/L_d_e_s = ' num2str(scale)]},'FontSize',16)
% title({'Length Normalisation Comparison','Truss Stiffness Formula : F_t_r_u_s_s = \DeltaL/L_d_e_s',['Scale = L_c/L_d_e_s = ' num2str(scale)]},'FontSize',16)
xlabel('Iter','FontSize',12)
ylabel('log(norm(err))','FontSize',12)
axis auto

dim = [.2 .5 .3 .3];
annotation('textbox',dim,'String','\DeltaL = L_d_e_s - L_c','FitBoxToText','on');



format long
results